#property copyright "master_255"
#define   VER       "1.7"
#property strict

#include <stderror.mqh>
#include <stdlib.mqh>

extern int    MagicNumber = 9999;
extern int    slip = 3;
extern double Lots = 0.1;
extern int    DepoPer001Lot = 0;
extern string _2 = "";
extern int    DistancePoint = 200;
input  int    DeletePending = 1;
extern int    DistancePendingAfterBE = 0;
input  int    CloseNewDayPercent = 20;
extern string _3 = "";
input  int    BodyShadowPercent = 100;
extern int    MaxCandlePips = 1500;
input  double iVarMaximum = 0;
extern string _4 = "   ";
extern int    BreakEvenAfterPips = 200;
input  int    CloseAfterBEPercent = 50;
extern int    TrailStart = 300;
extern int    TrailStop = 200;
extern int    TrailStep = 100;
//---------------------------
double minLot, maxLot;
string EAName="Test imperia "+VER;
datetime timeprev = 0, TimeLastTrail=0, LastOpen=0;
int LastHistoryTotal=0,ht=0, Min_Dist;
bool RealTrade=false; 
//+------------------------------------------------------------------+
int OnInit() {
   minLot  = MarketInfo(Symbol(), MODE_MINLOT);
   maxLot  = MarketInfo(Symbol(), MODE_MAXLOT);
   Min_Dist= (int)MarketInfo(Symbol(), MODE_STOPLEVEL);

   if (_Digits == 2 || _Digits == 4){
        DistancePoint /= 10;
        TrailStart /= 10;
        TrailStop /= 10;
        TrailStep /= 10;
        MaxCandlePips /= 10;
        BreakEvenAfterPips /= 10;
        DistancePendingAfterBE /= 10;
        slip /= 10; if(slip<1) slip=1;
        Print("Correction 4 digits: DistancePoint:",DistancePoint," BreakEvenAfterPips:",BreakEvenAfterPips," TrailStart:",TrailStart," TrailStop:",TrailStop," slp:",slip);
   }

   if(!IsTesting() && !IsOptimization()) RealTrade=true;
   
   return (INIT_SUCCEEDED);
}
//
void OnTick(){
   int i;
   //   
   if(TrailStop>0){
      if(TimeLastTrail+60 < TimeCurrent()){
         TrailingStandart(MagicNumber, TrailStop);
         TimeLastTrail=TimeCurrent();
      }
   }
   
   ht=OrdersHistoryTotal();
   if(LastHistoryTotal!=ht){
      LastHistoryTotal=ht;
      
      //         
      if(DeletePending==2){
         for(int iPos=ht-1; iPos >= 0; iPos--){
            if (OrderSelect(iPos, SELECT_BY_POS, MODE_HISTORY) && OrderSymbol()==_Symbol){
               if(OrderOpenTime()>=LastOpen && OrderProfit()>=0){
                  DeleteAllPending();
               }
               break;
            }
         }
      }
      
      //       
      if(DistancePendingAfterBE>0){
         for(int iPos=ht-1; iPos >= 0; iPos--){
            if (OrderSelect(iPos, SELECT_BY_POS, MODE_HISTORY) && OrderSymbol()==_Symbol){
               if(OrderOpenTime()>=LastOpen && OrderOpenPrice()==OrderClosePrice()){
                  for(i=OrdersTotal()-1;i>=0;i--){
                     if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==false) continue;
                     if (OrderSymbol() != _Symbol || OrderMagicNumber() != MagicNumber) continue;
                     if(OrderType()==OP_BUYSTOP)  OrderModifyX(OrderTicket(),Ask+DistancePendingAfterBE*_Point,OrderStopLoss(),0,OrderExpiration(),clrDarkOrange);
                     if(OrderType()==OP_SELLSTOP) OrderModifyX(OrderTicket(),Bid-DistancePendingAfterBE*_Point,OrderStopLoss(),0,OrderExpiration(),clrDarkOrange);
                  }
               }
               break;
            }
         }
      }
   }
   
   //    
   if(DeletePending==1){
      for(i=OrdersTotal()-1;i>=0;i--){
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==false) continue;
         if (OrderSymbol() != _Symbol || OrderMagicNumber() != MagicNumber) continue;
         if(OrderType()<2){
            DeleteAllPending();
            break;
         } 
      }
   }

   //   ,        
   if((DayOfWeek()==5 && TimeHour(TimeCurrent())>=22) || DayOfWeek()==1){
      for(i=OrdersTotal()-1;i>=0;i--){
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==false) continue;
         if (OrderSymbol() != _Symbol || OrderMagicNumber() != MagicNumber) continue;
         if(OrderType()>1) if(!OrderDelete(OrderTicket())) Print("  : ", GetLastError());
         if(OrderType()==OP_BUY) OrderCloseX(OrderTicket(), OrderLots(), OP_BUY, slip);
         if(OrderType()==OP_SELL) OrderCloseX(OrderTicket(), OrderLots(), OP_SELL, slip);
      }
   }
   
   //  ,   
   if(BreakEvenAfterPips>0){
      if(RealTrade) Min_Dist=(int)MarketInfo(Symbol(),MODE_STOPLEVEL);
      BreakEvenAfterPips = MathMax(BreakEvenAfterPips, Min_Dist);
      for(i=OrdersTotal()-1;i>=0;i--){
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==false) continue;
         if (OrderSymbol() != _Symbol || OrderMagicNumber() != MagicNumber) continue;
         if(OrderType()==OP_BUY && Bid>=OrderOpenPrice()+(BreakEvenAfterPips)*_Point && OrderStopLoss()<OrderOpenPrice()){
            OrderModifyX(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),0,0,clrDarkOrange);
            if(CloseAfterBEPercent>0){
               OrderCloseX(OrderTicket(), OrderLots()*CloseAfterBEPercent/100, OP_BUY, slip);
            }
         }
         if(OrderType()==OP_SELL && Ask<=OrderOpenPrice()-(BreakEvenAfterPips)*_Point && OrderStopLoss()>OrderOpenPrice()){
            OrderModifyX(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),0,0,clrDarkOrange);
            if(CloseAfterBEPercent>0){
               OrderCloseX(OrderTicket(), OrderLots()*CloseAfterBEPercent/100, OP_SELL, slip);
            }
         }
      }
   }
   
   //  
   if (timeprev == iTime(_Symbol, PERIOD_D1,0)) return;
   timeprev = iTime(_Symbol, PERIOD_D1,0);
   
   //     
   if(CloseNewDayPercent>0){
      for(i=OrdersTotal()-1;i>=0;i--){
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==false) continue;
         if (OrderSymbol() != _Symbol || OrderMagicNumber() != MagicNumber) continue;
         if(OrderProfit()>0){
            OrderCloseX(OrderTicket(), OrderLots()*CloseNewDayPercent/100 , OrderType(), slip);
         }
      } 
   }

   //   
   if(DayOfWeek()!=2) return;
   
   //     
   for(i=OrdersTotal()-1;i>=0;i--){
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==false) continue;
      if(OrderSymbol() != _Symbol || OrderMagicNumber() != MagicNumber) continue;
      if(TimeDayOfYear(OrderOpenTime()) == DayOfYear()){LastOpen=OrderOpenTime(); return;}
   } 

   // 
   if(DepoPer001Lot>0){
      Lots = NormalizeDouble((AccountFreeMargin()/DepoPer001Lot)/100,2);
      if(Lots<minLot) Lots = minLot; 
   }
   
   // 
   if(iVarMaximum>0){
      if(iCustom(_Symbol,_Period,"iVar",0,1)>iVarMaximum){
         DrawWarn("iVar > "+DoubleToStr(iVarMaximum,2));
         return;
      }
   }

   double body,upShadow,downShadow;
   if(iOpen(_Symbol, PERIOD_D1,1) > iClose(_Symbol, PERIOD_D1,1)){ 
      body = iOpen(_Symbol, PERIOD_D1,1)-iClose(_Symbol, PERIOD_D1,1);
      upShadow = iHigh(_Symbol, PERIOD_D1,1)-iOpen(_Symbol, PERIOD_D1,1);
      downShadow = iClose(_Symbol, PERIOD_D1,1)-iLow(_Symbol, PERIOD_D1,1);
   }else{
      body = iClose(_Symbol, PERIOD_D1,1)-iOpen(_Symbol, PERIOD_D1,1);
      upShadow = iHigh(_Symbol, PERIOD_D1,1)-iClose(_Symbol, PERIOD_D1,1);
      downShadow = iOpen(_Symbol, PERIOD_D1,1)-iLow(_Symbol, PERIOD_D1,1);
   }
   
   if(MaxCandlePips>0){
      if((iHigh(_Symbol, PERIOD_D1,1)-iLow(_Symbol, PERIOD_D1,1))/_Point > MaxCandlePips){
         DrawWarn("  ");
         return;
      }
   }
   
   if(BodyShadowPercent>0){
      if(upShadow>=(body*BodyShadowPercent/100) || downShadow>=(body*BodyShadowPercent/100)){
         DrawWarn("  "+IntegerToString(BodyShadowPercent)+"% ");
         return;
      }
   }
   
   //
   double boprice = iHigh(_Symbol, PERIOD_D1,1)+DistancePoint*_Point;
   double soprice = iLow(_Symbol, PERIOD_D1,1)-DistancePoint*_Point;
   if(!OrderSend(_Symbol, OP_BUYSTOP, Lots, boprice, slip, soprice, 0, EAName, MagicNumber, TimeCurrent()+PERIOD_W1*60, Blue))
      Print("  : ", ErrorDescription(GetLastError()));
   if(!OrderSend(_Symbol, OP_SELLSTOP, Lots, soprice, slip, boprice, 0, EAName, MagicNumber, TimeCurrent()+PERIOD_W1*60, HotPink))
      Print("  : ", ErrorDescription(GetLastError()));
   LastOpen=Time[0];
   
   if(_Period < PERIOD_D1){
      string N=TimeToStr(Time[0])+"_candle";
      ObjectCreate(N,OBJ_RECTANGLE,0,iTime(_Symbol,PERIOD_D1,1),iHigh(_Symbol,PERIOD_D1,1),Time[1],iLow(_Symbol,PERIOD_D1,1),0,0);
      ObjectSet(N,OBJPROP_BACK,false);
      ObjectSet(N,OBJPROP_COLOR,clrBlue);
   }
}

//
void DeleteAllPending(){
   for(int i=OrdersTotal()-1;i>=0;i--){
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==false) continue;
      if (OrderSymbol() != _Symbol || OrderMagicNumber() != MagicNumber) continue;
      if(OrderType()>1) if(!OrderDelete(OrderTicket())) Print("  : ", GetLastError());
   }
}

void OrderCloseX(int ticket1, double lots, int otype, int slp, color clr=CLR_NONE){
    int err = 0; double price = 0;
    bool exit_loop = false;

    int retry = 10;
    int cnt1   = 0;

    lots = NormalizeDouble(lots,2);
    if(lots<minLot) return;
    
    while(!exit_loop && cnt1<retry){
        if(otype == OP_BUY)  price=Bid;
        if(otype == OP_SELL) price=Ask;
        if(!OrderClose(ticket1, lots, price, slp, clr)){
           err = GetLastError();
           switch(err){
             case ERR_INVALID_PRICE:
                  RefreshRates();
                  break;
             case ERR_REQUOTE:
                  RefreshRates();
                  break;
             case ERR_OFF_QUOTES:
                  RefreshRates();
                  break;
             case ERR_BROKER_BUSY:
                  break;
             default:
                  exit_loop = true;
                  break;
           }
           Sleep(1000);
           cnt1++;
        }else
           exit_loop = true;
   }
      
   if(err != ERR_NO_ERROR && err != ERR_NO_RESULT) Print ("   #" + IntegerToString(ticket1) + "  : " + ErrorDescription(err));
}
//+------------------------------------------------------------------+
double ND(double ad_0) {
   return (NormalizeDouble(ad_0, _Digits));
}


void OrderModifyX(int ticket1, double price, double stoploss, double takeprofit, datetime expiration, color arrow_color=CLR_NONE){
    int err = 0;
    bool exit_loop = false;

    int retry = 10;
    int cnt1   = 0;
    
    while(!exit_loop && cnt1<retry){
        if(!OrderModify(ticket1, price, stoploss, takeprofit, expiration, arrow_color)){
           err = GetLastError();
           switch(err){
             case ERR_REQUOTE:
                  RefreshRates();
                  break;
             case ERR_OFF_QUOTES:
                  RefreshRates();
                  break;
             case ERR_BROKER_BUSY:
                  break;
             default:
                  exit_loop = true;
                  break;
           }
           Sleep(1000);
           cnt1++;
        }else
           exit_loop = true;
   }
      
   if(err != ERR_NO_ERROR && err != ERR_NO_RESULT) Print ("   #" + IntegerToString(ticket1) + "  : " + ErrorDescription(err));
}


void TrailingStandart(int CurrentMagic, int trldistance){ 
   double nextsl,sl,tp;
   int trlstart=TrailStart;
  
   Min_Dist=(int)MarketInfo(Symbol(),MODE_STOPLEVEL);
   if(trldistance<Min_Dist){
      //Print("StopLevel: "+Min_Dist+" < stop: "+stop);
      trlstart+=Min_Dist-trldistance;
      trldistance=Min_Dist;
   }
   
   int total=OrdersTotal();
   for(int pos=0;pos<total;pos++) {
      if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES)==false) continue;
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != CurrentMagic) continue;

      sl=ND(OrderStopLoss());
      if(sl>0) trldistance+=TrailStep;
      if (OrderType()==OP_BUY){
         if(Bid>OrderOpenPrice()+ND(trlstart*_Point)){
            nextsl = ND(Bid - trldistance*_Point);
            tp = ND(OrderTakeProfit());
            if(nextsl>=tp) tp=0;
            if(nextsl>sl || sl==0){
               OrderModifyX(OrderTicket(),OrderOpenPrice(),nextsl,tp,0,clrDarkOrange);
            }
         }
      }
      
      if (OrderType()==OP_SELL){ 
         if(Ask<OrderOpenPrice()-ND(trlstart*_Point)){
            nextsl = ND(Ask + trldistance*_Point);
            tp = ND(OrderTakeProfit());
            if(nextsl<=tp) tp=0;
            if((nextsl<sl || sl==0)){
               OrderModifyX(OrderTicket(),OrderOpenPrice(),nextsl,tp,0,clrDarkOrange);
            }
         }
      }   
   }    
}

//--------
void DrawWarn(string text){
   if(RealTrade || IsVisualMode()){
      string obid=_Symbol+TimeToStr(Time[1]);
      if(ObjectFind(obid)!=-1) ObjectDelete(obid);
      
      ENUM_ANCHOR_POINT anc;
      double price;
   
      if((WindowPriceMax()+WindowPriceMin())/2 < Bid){
         price=Low[1];
         anc=ANCHOR_RIGHT;
      }else{
         price=High[1];
         anc=ANCHOR_LEFT;
      }
      
      ObjectCreate(obid, OBJ_TEXT, 0, Time[1], price);
      ObjectSet(obid, OBJPROP_ANGLE, 90);
      ObjectSet(obid,OBJPROP_ANCHOR,anc);
      ObjectSet(obid,OBJPROP_BACK,false);
      ObjectSetText(obid,text,10,"Arial",clrPlum);
   }
}

//--------

double OnTester(){
  double Res = 0;
  double MaxDD = TesterStatistics(STAT_EQUITY_DD);
  if (MaxDD != 0)
      Res = TesterStatistics(STAT_PROFIT) / MaxDD;
  return Res;
}